選択できるのは25トピックまでです。 トピックは、先頭が英数字で、英数字とダッシュ('-')を使用した35文字以内のものにしてください。

shrc 30 KiB

11年前
11年前
9年前
11年前
12年前
11年前
11年前
11年前
10年前
11年前
11年前
11年前
11年前
11年前
11年前
11年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
11年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
12年前
11年前
11年前
12年前
11年前
12年前
12年前
12年前
11年前
11年前
12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196119711981199120012011202120312041205120612071208120912101211121212131214121512161217121812191220122112221223122412251226122712281229123012311232123312341235123612371238123912401241124212431244124512461247124812491250125112521253125412551256125712581259126012611262126312641265126612671268126912701271127212731274127512761277127812791280128112821283128412851286128712881289129012911292129312941295129612971298129913001301130213031304130513061307130813091310131113121313
  1. #!/bin/sh
  2. # TODO: decide the naming scheme of variables (global, local, ...)
  3. expr "$-" : '^.*i' >/dev/null || return
  4. ##########################################
  5. __shrc_lock=/tmp/shrc_lock.$USER.$$
  6. test -f "$__shrc_lock" && return
  7. touch "$__shrc_lock"
  8. ##########################################
  9. null(){
  10. "$@" >/dev/null 2>&1
  11. }
  12. __safe_run(){
  13. type $1 >/dev/null 2>&1 && "$@"
  14. }
  15. __match(){
  16. # __match str word
  17. # return 0 if word is found in str
  18. expr "$1" : ".*$2.*" >/dev/null
  19. }
  20. __lf=$'\n'
  21. __cr=$'\r'
  22. test -n "$TMP" || export TMP=/tmp/${USER}-tmp
  23. mkdir -p "$TMP"
  24. __homerun="$HOME/.var/run"
  25. mkdir -p "$__homerun"
  26. ##########################
  27. # system type
  28. gnu_coreutils=false # for mac
  29. null ls --version && gnu_coreutils=true
  30. inbash=false
  31. inzsh=false
  32. if test -n "$BASH_VERSION"
  33. then
  34. inbash=true
  35. elif test -n "$ZSH_VERSION"
  36. then
  37. inzsh=true
  38. fi
  39. #################################
  40. # file pathes:
  41. # shrc: Path to this file
  42. if $inbash
  43. then
  44. __shrc="$BASH_SOURCE"
  45. elif $inzsh
  46. then
  47. __shrc="$0"
  48. fi
  49. #########################
  50. # system detection
  51. __system_shrc="$__homerun/system.shrc"
  52. if test -f "$__system_shrc"
  53. then
  54. . "$__system_shrc"
  55. else
  56. ismsys=false
  57. iscygwin=false
  58. iswindows=false
  59. isdarwin=false
  60. isfreebsd=false
  61. isbsd=false
  62. islinux=false
  63. # $OSTYPE is another choice. which is better?
  64. # NOTE: sh on FreeBSD does not define OSTYPE
  65. case `uname` in
  66. MINGW*) ismsys=true ;;
  67. CYGWIN*) iscygwin=true ;;
  68. Darwin*) isdarwin=true ;;
  69. FreeBSD*) isfreebsd=true ;;
  70. Linux*) islinux=true ;;
  71. esac
  72. ($ismsys || $iscygwin) && iswindows=true
  73. # is this true?
  74. ($isdarwin || $isfreebsd) && isbsd=true
  75. # dump system detection result
  76. cat <<__EOC__ >"$__system_shrc"
  77. #!/bin/sh
  78. # $__system_shrc
  79. ismsys=$ismsys
  80. iscygwin=$iscygwin
  81. iswindows=$iswindows
  82. isdarwin=$isdarwin
  83. isfreebsd=$isfreebsd
  84. isbsd=$isbsd
  85. islinux=$islinux
  86. __EOC__
  87. fi
  88. $ismsys && export HOSTNAME
  89. # adhoc fix for ansible on cygwin
  90. # http://blog.s-uni.net/2013/08/27/ansible-running-on-cygwin/
  91. if $iscygwin
  92. then
  93. export ANSIBLE_SSH_ARGS="-o ControlMaster=no"
  94. fi
  95. ##########################
  96. # Terminal setups
  97. if ! $iswindows && null type stty
  98. then
  99. stty stop undef # unbind C-s to stop displaying output
  100. # stty erase '^h'
  101. fi
  102. # Zsh specific preferences
  103. # http://www.clear-code.com/blog/2011/9/5.html
  104. if $inzsh
  105. then
  106. bindkey -e
  107. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  108. autoload compinit; compinit
  109. # supress cycle by tab
  110. unsetopt auto_menu
  111. # unsetopt correct
  112. setopt complete_aliases
  113. setopt auto_list
  114. setopt bash_auto_list
  115. setopt magic_equal_subst
  116. setopt list_types
  117. # what is the difference of these two?
  118. setopt auto_param_slash
  119. setopt mark_dirs
  120. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  121. zstyle ':completion:*' format '%B%d%b'
  122. zstyle ':completion:*' group-name ''
  123. zstyle ':completion:*' use-cache yes
  124. # zstyle ':completion:*:cd:*' tag-order local-directories
  125. zstyle ':completion:*' completer _complete _bash_completions \
  126. _history
  127. # zstyle ':completion:*:*:cd:*' completer
  128. zstyle ':completion:*' accept-exact-dirs true
  129. zstyle ':completion:*' special-dirs true
  130. autoload colors; colors
  131. # autoload -Uz promptinit
  132. # promptinit
  133. # prompt walters
  134. setopt hist_ignore_dups
  135. setopt hist_ignore_all_dups
  136. setopt hist_save_no_dups
  137. setopt extended_history
  138. setopt share_history
  139. setopt append_history
  140. HISTFILE=$HOME/.zsh-history
  141. HISTSIZE=100000
  142. SAVEHIST=100000
  143. setopt prompt_subst
  144. setopt interactive_comments
  145. fi
  146. ######################
  147. # Print welcome messages
  148. command -v fortune >/dev/null && {
  149. if command -v cowsay >/dev/null
  150. then
  151. fortune | cowsay
  152. echo
  153. fortune -o | cowsay
  154. echo
  155. else
  156. fortune
  157. echo
  158. fortune -o
  159. echo
  160. fi
  161. }
  162. if null type figlet && null type lolcat
  163. then
  164. hostname -s | figlet | lolcat
  165. fi
  166. uname -a
  167. $iswindows && alias tty="echo cmd.exe"
  168. echo TERM $TERM with $(tput colors) colors using $(tty)
  169. echo umask: `umask -S`
  170. echo
  171. __safe_run w yuk
  172. # if null type tmux
  173. # then
  174. # echo
  175. # echo tmux sessions:
  176. # tmux ls 2>/dev/null| sed -e 's/^/ /g'
  177. # echo
  178. # fi
  179. # if test -n "$TMUX"
  180. # then
  181. # tmux display -p \
  182. # 'TMUX #S:#I:#W.#P, client TERM: #{client_termname}' \
  183. # 2>/dev/null
  184. # echo
  185. # fi
  186. if test -n "$__MY_DTACH"
  187. then
  188. echo
  189. echo DSession: Current Session: "`basename "$__MY_DTACH"`"
  190. echo DSession: Press C-^ to Exit.
  191. true
  192. fi
  193. i(){
  194. w
  195. ss -lnp
  196. ps aufx
  197. df -h
  198. top -b -d 1 -n 1
  199. top -b -d 1 -n 1 -a
  200. dstat -taf 1 10
  201. }
  202. ###################################
  203. # some aliases and functions
  204. # __func_name: never used interactively
  205. # _func_name: usually not used interactively
  206. __safe_alias(){
  207. # __safe_alias <name>=<command>
  208. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  209. test -n "$_bin" && \
  210. null type $_bin && \
  211. alias "$1"
  212. }
  213. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  214. # color prefs
  215. if $gnu_coreutils
  216. then
  217. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  218. # gnu coreutils LS_COLORS is used
  219. null type dircolors && eval `dircolors`
  220. _coloroption=" --color=auto"
  221. else
  222. # export LSCOLORS=gxfxcxdxbxegedabagacad
  223. export LSCOLORS=DxGxcxdxCxegedabagacad
  224. export CLICOLOR=1
  225. fi
  226. alias ls="ls -hCF${_coloroption}${_timeoption}"
  227. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  228. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  229. _timeformat_num="%Y%m%d%H%M%S"
  230. alias datenum="date +$_timeformat_num"
  231. alias less="less -FX"
  232. __safe_alias em="emacs -nw"
  233. test -n "$_VI_ALT" && alias vi=$_VI_ALT
  234. alias pstree="LANG=C pstree"
  235. alias cp="cp -v"
  236. alias mv="mv -v"
  237. alias rm="rm -v"
  238. alias mkdir="mkdir -v"
  239. $gnu_coreutils && alias rmdir="rmdir -v"
  240. alias psaux="ps auxww"
  241. alias modest="ionice -c 2 -n 7 nice -n 19"
  242. alias e=exec
  243. __safe_alias e3=e3em
  244. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  245. alias po=popd
  246. alias pu=pushd
  247. __safe_alias sudo="sudo " # use aliases through sudo
  248. __safe_alias sudoe="sudoedit"
  249. __safe_alias make="nice make"
  250. __safe_alias brew="nice brew"
  251. __safe_alias gcc="nice gcc"
  252. __safe_alias go="nice go"
  253. __safe_alias git="nice git"
  254. __safe_alias javac="nice javac -J-Duser.language=en"
  255. __safe_alias ansible-playbook="nice ansible-playbook"
  256. alias rand="echo \$RANDOM"
  257. alias pycalc="python -i -c 'from math import *' "
  258. __safe_alias py3=python3
  259. __safe_alias py2=python2
  260. __safe_alias ipy=ipython
  261. __safe_alias ipy3=ipython3
  262. __safe_alias ipy2=ipython2
  263. __safe_alias rl=rlwrap
  264. __safe_alias igosh=gosh-rl
  265. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  266. # SHELL is set to be /bin/zsh
  267. if $inbash
  268. then
  269. alias _reloadrc="rm '$__shrc_lock'; exec bash"
  270. elif $inzsh
  271. then
  272. alias _reloadrc="rm '$__shrc_lock'; exec zsh"
  273. else
  274. alias _reloadrc="rm '$__shrc_lock'; exec $SHELL"
  275. fi
  276. # alias mytime="date +%Y%m%d-%H%M%S"
  277. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  278. # some extra utilities
  279. __safe_alias mpg123="mpg123 -C -v --title"
  280. #export PLAYER="mpg123 -C -v --title"
  281. __safe_alias screen="screen -e^z^z"
  282. #alias zcd="cd \`zenity --file-selection --directory\`"
  283. __safe_alias gtags="gtags --verbose"
  284. __safe_alias htags="htags --xhtml --symbol --line-number \
  285. --frame --alphabet --verbose"
  286. __safe_alias au=aunpack
  287. # __safe_alias lv="lv|less"
  288. __safe_alias rs="rsync --progress --itemize-changes --compress"
  289. __safe_alias vagr=vagrant
  290. __safe_alias ztw='twitter set "`zenity --entry --title ztw --text Status:`"'
  291. if $iscygwin
  292. then
  293. __my_wget_options=" --no-check-certificate"
  294. __safe_alias wget="wget $__my_wget_options"
  295. fi
  296. if $isdarwin
  297. then
  298. alias updatedb="LC_ALL=C updatedb"
  299. # do not use locate installed by macports
  300. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  301. fi
  302. # somehow not work
  303. # typeset -ga chpwd_functions
  304. # chpwd_functions+=pwd
  305. # chpwd(){
  306. # pwd
  307. # }
  308. cd(){
  309. builtin cd "$@" && pwd
  310. }
  311. root(){
  312. if test "`git rev-parse --is-inside-work-tree 2>/dev/null`" = true
  313. then
  314. cd "`git rev-parse --show-toplevel`"
  315. else
  316. cd /
  317. fi
  318. }
  319. __find_latest_vimdir(){
  320. vimdir=/usr/share/vim
  321. if test -d "$vimdir"
  322. then
  323. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  324. else
  325. echo ""
  326. fi
  327. }
  328. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  329. do
  330. test -n "$f" || continue
  331. f="$f/macros/less.sh"
  332. test -f $f && alias vl=$f && break
  333. done
  334. __safe_alias pa="pacman --color=always"
  335. __safe_alias pa="pacmatic --color=always"
  336. __safe_alias pa="pacapt"
  337. __safe_alias yt=yaourt
  338. # variable for yaourt
  339. null type pacmatic && export PACMAN="pacmatic"
  340. __safe_alias cower="cower --color=auto"
  341. __my_pacman_update_mirrorlist_with_reflector(){
  342. f=/etc/pacman.d/mirrorlist
  343. cmd="$(expr "$(grep -m 1 reflector $f)" : '# With: *\(.*\)')"
  344. if test -z "$cmd"
  345. then
  346. cmd="reflector --verbose --number 5 --sort rate --protocol http --protocol https --save $f"
  347. fi
  348. echo ">>> $cmd ..." 1>&2
  349. sudo sh -c "$cmd" && cat $f
  350. }
  351. null type reflector && test -d /etc/pacman.d && \
  352. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  353. null type apt-get && {
  354. alias aupgrade="sudo sh -xc 'apt-get autoremove --yes && \
  355. apt-get update --yes && apt-get upgrade --yes'"
  356. alias aptin="apt-get install"
  357. alias aptsearch="apt-cache search"
  358. alias aptshow="apt-cache show"
  359. }
  360. null type port && {
  361. alias port="port -v"
  362. alias pupgrade="sudo sh -xc 'port -v selfupdate && \
  363. port -v upgrade outdated'"
  364. }
  365. if $iscygwin
  366. then
  367. null type windate || \
  368. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  369. # alias cygsu="cygstart /cygwinsetup.exe"
  370. fi
  371. mkpatch(){
  372. if test $# -eq 0
  373. then
  374. echo "usage: mkpatch <olddir> <newdir>"
  375. elif ! test -d "$1"
  376. then
  377. echo "mkpatch: $1 is not a directory"
  378. elif ! test -d "$2"
  379. then
  380. echo "mkpatch: $2 is not a directory"
  381. else
  382. diff -Naur "$1" "$2"
  383. fi
  384. }
  385. __sdcv_less(){
  386. command sdcv -n "$@" | less --quit-if-one-screen
  387. }
  388. command -v sdcv >/dev/null && alias dict=__sdcv_less
  389. __safe_alias g="git "
  390. $isdarwin && $inbash && \
  391. . /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-completion.bash
  392. if null type _git && $inbash
  393. then
  394. # enable programmable completion for g
  395. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  396. || complete -o default -o nospace -F _git g
  397. fi
  398. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  399. __safe_alias m=gitmemo
  400. #alias setup.py3="sudo python3 setup.py install --record files.txt"
  401. randomstr(){
  402. len=$1
  403. test -z "$len" && len=8
  404. uuidgen | tr -d - | cut -c 1-len
  405. }
  406. datestr(){
  407. # datestr YYYYMMDDhhmmss
  408. if test -z "$1" || test "$1" = "-h"
  409. then
  410. echo "datestr: usage: datestr <YYYYMMDDhhmmss>"
  411. return 1
  412. fi
  413. # actual format for date command
  414. dfmt="`echo "$1" | \
  415. sed -e 's/YYYY/%Y/g' -e 's/yyyy/%Y/g' -e 's/YY/%y/g' -e 's/yy/%y/g' |\
  416. sed -e 's/MM/%m/g' -e 's/DD/%d/g' -e 's/dd/%d/g' | \
  417. sed -e 's/HH/%H/g' -e 's/hh/%H/g' -e 's/mm/%M/g' -e 's/SS/%S/g' -e 's/ss/%S/g'`"
  418. date +"$dfmt"
  419. }
  420. # ssh(){
  421. # # __my_terminal_title ssh
  422. # command ssh "$@"
  423. # }
  424. __ssh_with_cd(){
  425. # __ssh_with_cd <host> <directory> [<arg> ...]
  426. if test -z "$2"
  427. then
  428. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  429. return 1
  430. fi
  431. host="$1"
  432. shift
  433. dir="$1"
  434. shift
  435. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  436. }
  437. memo(){
  438. if test -z "$1"
  439. then
  440. _memo="memo.txt"
  441. else
  442. _memo="$1/memo.txt"
  443. fi
  444. $EDITOR "$_memo"
  445. if test -z "`cat "$_memo"`"
  446. then
  447. echo "$_memo is empty. Removing."
  448. rm "$_memo"
  449. fi
  450. }
  451. now(){
  452. ___tformat="%Y/%m/%d %H:%M:%S %z"
  453. cal
  454. REPLY=
  455. printf "\\r`date "+${___tformat}"`"
  456. read -t 1
  457. while test $? -ne 0
  458. do
  459. printf "\\r`date "+${___tformat}"`"
  460. read -t 1
  461. done
  462. }
  463. s(){
  464. if git rev-parse --git-dir >/dev/null 2>&1
  465. then
  466. echo ">> git grep -n $@" 1>&2
  467. git grep -n "$@"
  468. elif which ag >/dev/null 2>&1
  469. then
  470. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  471. ag --pager="$PAGER" "$@"
  472. elif which ack >/dev/null 2>&1
  473. then
  474. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  475. ack --pager="$PAGER" "$@"
  476. else
  477. echo \
  478. ">> find . " \
  479. "-path '*/.git' -prune -o" \
  480. "-path '*/.svn' -prune -o" \
  481. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  482. if test $# -eq 0
  483. then
  484. echo "No search word given." 1>&2
  485. return 1
  486. fi
  487. find . \
  488. -path '*/.git' -prune -o \
  489. -path '*/.svn' -prune -o \
  490. -type -f -exec grep -nH -e --color=always "$@" {} + \
  491. | $PAGER
  492. fi
  493. }
  494. MYMANPATH='/usr/lib/erlang/man'
  495. if $inbash || $inzsh
  496. then
  497. man(){
  498. env \
  499. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  500. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  501. LESS_TERMCAP_me=$(printf "\e[0m") \
  502. LESS_TERMCAP_se=$(printf "\e[0m") \
  503. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  504. LESS_TERMCAP_ue=$(printf "\e[0m") \
  505. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  506. MANPATH="`manpath`:$MYMANPATH" \
  507. man "$@"
  508. }
  509. fi
  510. netwait(){
  511. while ! ping -c 1 -t 1 example.com
  512. do
  513. true
  514. done
  515. echo network works.
  516. }
  517. __realpath(){
  518. if type realpath >/dev/null 2>&1
  519. then
  520. command realpath "$@"
  521. else
  522. while ! test -d $1
  523. do
  524. shift
  525. done
  526. (command cd "$d" && echo "$PWD")
  527. # local d="$OLDPWD"
  528. # command cd "$1"
  529. # echo "$PWD"
  530. # command cd "$d"
  531. fi
  532. }
  533. if $isdarwin
  534. then
  535. # I want to use env -u, but darwin env does not provide this option
  536. null type tmux && alias tmux='SHLVL= tmux'
  537. else
  538. null type tmux && alias tmux='env -u SHLVL tmux'
  539. fi
  540. tx(){
  541. tmux start-server
  542. if test -z "$1"
  543. then
  544. echo "usage: tx [<session_name>]"
  545. tmux list-sessions
  546. elif test -z "$TMUX"
  547. then
  548. # -A: attach if already exists
  549. # tmux new-session -A -c "$HOME" -s "$1"
  550. tmux new-session -A -s "$1"
  551. else
  552. # create new session if not exists yet
  553. # tmux has-session -t "$1" || TMUX= tmux new-session -d -c "$HOME" -s "$1"
  554. tmux has-session -t "$1" || TMUX= tmux new-session -d -s "$1"
  555. tmux switch-client -t "$1"
  556. fi
  557. }
  558. __dsession(){
  559. # dt [-h] [<name>] [<command ...>]
  560. __dtach_dir="${TMP}/dtach"
  561. mkdir -p "${__dtach_dir}"
  562. if test -n "${__MY_DTACH}"
  563. then
  564. # if already in dtach session print current session
  565. soc_name="`basename "$__MY_DTACH"`"
  566. echo "Current session: ${soc_name}"
  567. fi
  568. if test -z "$1"
  569. then
  570. # if no arg given show list of sessions
  571. echo "Usage: ds [<session>]"
  572. echo "Sessions:"
  573. ls "${__dtach_dir}"
  574. return 0
  575. elif test "$1" = "-h"
  576. then
  577. echo "dt: usage: dt [-h] [<name>] [<command ...>]" 1>&2
  578. return 1
  579. fi
  580. # set socket name
  581. soc_name="${__dtach_dir}/$1"
  582. shift
  583. if test -n "$__MY_DTACH"
  584. then
  585. echo "dtach session cannot be nested." 1>&2
  586. return 1
  587. elif test -S "$soc_name"
  588. then
  589. dtach -a "$soc_name" -e ^^
  590. elif test -e "$soc_name"
  591. then
  592. echo "dt: File named $soc_name already exists."
  593. return 1
  594. elif test -z "$1"
  595. then
  596. # if no command given invoke current shell
  597. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  598. # echo "dt: Socket named $soc_name not exists and no command specified."
  599. # return 1
  600. else
  601. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  602. fi
  603. }
  604. null type dtach && alias ds=__dsession
  605. scr(){
  606. test -n "$1" && pf="${1}-"
  607. ___tformat="%Y%m%d-%H%M%S%z"
  608. ___file="${PWD}/${pf}`date +${___tformat}`.script"
  609. __MY_SCRIPT=${___file} script ${___file} "$@"
  610. }
  611. dtscr(){
  612. # dtscr <command ...>
  613. if test -z "$1"
  614. then
  615. echo "dtscr: usage: dtscr <command ...>"
  616. return 1
  617. fi
  618. ___cmdstr="`echo $@ | tr ' ' +`"
  619. ___tformat="%Y%m%d-%H%M%S%z"
  620. ___name="${pf}`date +${___tformat}`-${___cmdstr}"
  621. ___scr_file="${HOME}/${___name}.script"
  622. ___dt_dir="${TMP}/dtscr"
  623. mkdir -p "$___dt_dir"
  624. dtach -n "${___dt_dir}/${___name}" script "${___scr_file_}" "$@"
  625. # echo $_name
  626. # echo $_file
  627. }
  628. mcrypt_stream(){
  629. test $# -eq 2 || return 1
  630. case $1 in
  631. en)
  632. mcrypt --key $2 | base64 ;;
  633. de)
  634. base64 -d | mcrypt -d --key $2 ;;
  635. esac
  636. }
  637. gpg_stream(){
  638. test $# -eq 2 || return 1
  639. case $1 in
  640. en)
  641. gpg --passphrase $2 -c --batch |base64 ;;
  642. de)
  643. base64 -d|gpg --passphrase $2 -d --batch ;;
  644. esac
  645. }
  646. dgpg(){
  647. if test "$1" = help || test -z "$2"
  648. then
  649. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  650. return
  651. fi
  652. ___srcs="$2"
  653. ___dsts="$3"
  654. test -z "$___dsts" && ___dsts="${___srcs}.out"
  655. ___pw=
  656. echo -n "dgpg pw: "
  657. read -s ___pw
  658. echo ""
  659. test -z "$___pw" && return 1
  660. for f in *${___srcs}
  661. do
  662. ___d="$(basename "$f" "${___srcs}")${___dsts}"
  663. echo -n "Processing $f to $___d..."
  664. if test -d "$f"
  665. then
  666. echo "`printf 'failed (%s is directory)' $f`"
  667. elif test -f "$___d"
  668. then
  669. echo "`printf 'failed (%s is already exists)' $___d`"
  670. elif <"$f" gpg_stream $1 $___pw >"$___d" 2>/dev/null
  671. then
  672. echo "done"
  673. else
  674. echo "failed"
  675. test -f "$___d" && rm "$___d"
  676. fi
  677. done
  678. }
  679. alias enst="gpg_stream en"
  680. alias dest="gpg_stream de"
  681. showinfo(){
  682. echo "Japanese letters are 表示可能"
  683. __safe_run diskinfo
  684. ! $isdarwin && test -n "${DISPLAY}" && {
  685. __safe_run xrandr | \grep --color=never ^Screen
  686. }
  687. $iswindows || __safe_run finger $USER
  688. LANG=C __safe_runc id
  689. __safe_run xset q
  690. }
  691. x(){
  692. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  693. #mkdir -p ~/.var/log
  694. # nohup startx >~/.var/log/xorg.log 2>&1 &
  695. # exit
  696. exec startx
  697. else
  698. echo "X cant be started! Another X is already running?" 1>&2
  699. fi
  700. }
  701. bak(){
  702. for file in "$@"
  703. do
  704. cp -v ${file} ${file}.bak
  705. done
  706. }
  707. di(){
  708. if null type git
  709. then
  710. git --git-dir= diff "$@"
  711. ___diffcmd="git --git-dir= diff"
  712. else
  713. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  714. then
  715. ___diffcmd=colordiff
  716. else
  717. ___diffcmd=diff
  718. fi
  719. ${___diffcmd} -u "$@" | ${PAGER}
  720. fi
  721. }
  722. tb(){
  723. __datenum=`date +%Y%m%d-%H%M%S`
  724. __tb="$HOME/.var/tb/$__datenum"
  725. mkdir -p "$__tb"
  726. mv "$@" "$__tb"
  727. }
  728. mkdd(){
  729. _d=`date +%Y%m%d-%H%M%S` && \
  730. mkdir -p "$_d"
  731. }
  732. mkcd(){
  733. if test -z "$1"
  734. then
  735. echo "mkcd: usage: mkcd <dir>"
  736. return 1
  737. elif test -d "$1"
  738. then
  739. echo "Dir \"$1\" already exists."
  740. else
  741. mkdir -p "$1"
  742. echo "Dir \"$1\" created."
  743. fi
  744. cd "$1"
  745. }
  746. mkcdd(){
  747. # make and change date directory
  748. _d=`date +%Y%m%d-%H%M%S` && \
  749. mkcd "$_d"
  750. }
  751. if test -n "$TMUX" && null type reattach-to-user-namespace
  752. then
  753. alias pbpaste="reattach-to-user-namespace pbpaste"
  754. alias pbcopy="reattach-to-user-namespace pbcopy"
  755. fi
  756. catclip(){
  757. if $iswindows
  758. then
  759. cat /dev/clipboard | tr -d \\r
  760. elif $isdarwin
  761. then
  762. pbpaste
  763. else
  764. xclip -o -selection "clipboard"
  765. fi
  766. }
  767. setclip(){
  768. if test $# -eq 0
  769. then
  770. exec 3<&0
  771. else
  772. exec 3<<__EOF__
  773. `cat "$@"`
  774. __EOF__
  775. fi
  776. if $iswindows
  777. then
  778. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  779. elif $isdarwin
  780. then
  781. pbcopy 0<&3
  782. else
  783. 0<&3 xclip -i -f -selection "primary" | \
  784. xclip -i -f -selection "clipboard"
  785. fi
  786. exec 3<&-
  787. }
  788. open_file(){
  789. if $iscygwin
  790. then
  791. cygstart "$@"
  792. elif $ismsys
  793. then
  794. cmd.exe //c start "" "$@"
  795. elif $isdarwin
  796. then
  797. touch "$@"
  798. open "$@"
  799. elif $islinux
  800. then
  801. touch "$@"
  802. if null type pcmanfm; then
  803. LC_MESSAGES= pcmanfm "$@"
  804. else
  805. LC_MESSAGES= xdg-open "$@" &
  806. fi
  807. else
  808. cat "$@"
  809. fi
  810. }
  811. o(){
  812. if test $# -eq 0
  813. then
  814. open_file .
  815. else
  816. for f in "$@"
  817. do
  818. open_file "$(realpath "$f")"
  819. done
  820. fi
  821. }
  822. convmv_sjis2utf8_test(){
  823. convmv -r -f sjis -t utf8 *
  824. }
  825. convmv_sjis2utf8_notest(){
  826. convmv -r -f sjis -t utf8 * --notest
  827. }
  828. #################################################
  829. ## pastebin services
  830. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  831. sprunge(){
  832. # http://sprunge.us
  833. if test -z "$1"
  834. then
  835. curl -F 'sprunge=<-' http://sprunge.us
  836. else
  837. curl http://sprunge.us/$1
  838. fi
  839. }
  840. dpaste(){
  841. # http://dpaste.de
  842. if test -z "$1"
  843. then
  844. curl -F 'content=<-' https://dpaste.de/api/
  845. echo
  846. else
  847. curl https://dpaste.de/$1/raw/
  848. fi
  849. }
  850. ######################################
  851. ## Prompt Settings
  852. __my_moc_state(){
  853. type mocp >/dev/null 2>&1 || return
  854. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  855. printf "$1" "`mocp -Q %title 2>/dev/null`"
  856. }
  857. __my_parse_svn_branch() {
  858. ___svn_url=$(LANG=C svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  859. ___svn_repository_root=$(LANG=C svn info 2>/dev/null | \
  860. sed -ne 's#^Repository Root: ##p')
  861. echo ${___svn_url} | sed -e 's#^'"${___svn_repository_root}"'##g' | \
  862. awk '{print $1}'
  863. }
  864. __my_svn_ps1(){
  865. if svn status >/dev/null 2>&1
  866. then
  867. ___svn_branch=$(__my_parse_svn_branch)
  868. test -n "${___svn_branch}" && printf "$1" "{$___svn_branch}"
  869. fi
  870. }
  871. __my_battery_status(){
  872. ___dir=/sys/class/power_supply/BAT0
  873. if test -d $___dir && test -r $___dir/status && test -r $___dir/charge_full && \
  874. test -r $___dir/charge_now
  875. then
  876. ___st=$(cat $___dir/status)
  877. ___full=$(cat $___dir/charge_full)
  878. ___now=$(cat $___dir/charge_now)
  879. ___rate=$(expr "$___now" \* 100 / "$___full")
  880. printf "$1" "${___st}:${___rate}%"
  881. fi
  882. }
  883. alias bat='__my_battery_status %s\\n'
  884. __my_ps1_scale(){
  885. if null type stty && ! $ismsys
  886. then
  887. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  888. fi
  889. }
  890. __my_ps1_tmux(){
  891. null type tmux || return $last
  892. ___tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  893. test -n "$TMUX" && echo "[TMUX:$___tmuxc]"
  894. }
  895. __my_ps1_moc(){
  896. __my_moc_state "[MOC:%s]"
  897. }
  898. for f in /usr/share/git/git-prompt.sh \
  899. /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-prompt.sh \
  900. /usr/local/opt/bash-git-prompt/share/gitprompt.sh \
  901. "`brew --prefix 2>/dev/null`"/etc/bash_completion.d/git-prompt.sh \
  902. /usr/share/git-core/contrib/completion/git-prompt.sh \
  903. /usr/local/share/git-core/contrib/completion/git-prompt.sh \
  904. /etc/bash_completion.d/git-prompt \
  905. /opt/local/share/git-core/git-prompt.sh \
  906. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  907. do
  908. if test -r "$f" && ($inbash || $inzsh)
  909. then
  910. . "$f"
  911. break
  912. fi
  913. done
  914. export GIT_PS1_SHOWDIRTYSTATE=t
  915. export GIT_PS1_SHOWUPSTREAM=t
  916. __my_ps1_git(){
  917. null type __git_ps1 || return $last
  918. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  919. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  920. }
  921. __printf_ipaddr(){
  922. # ipaddress <fmt>
  923. type ip >/dev/null 2>&1 || return 1
  924. ___ip=$(LANG=C ip addr show scope global | \
  925. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  926. test -n "$___ip" && printf "$1" $___ip
  927. }
  928. alias addr="__printf_ipaddr '%s'"
  929. __my_ps1_ipaddr(){
  930. ! $iswindows && __printf_ipaddr '[Addr:%s]'
  931. }
  932. __my_ps1_bttry(){
  933. ___bst="$__homerun/batterystatus"
  934. if test -z "$DISPLAY" && ! $iswindows
  935. then
  936. test -f $___bst && ___bstr="$(cat $___bst)"
  937. test -n "$___bstr" && ! echo $___bstr | grep 100 >/dev/null 2>&1 && \
  938. echo "[Battery:${___bstr}]"
  939. __my_battery_status %s >$___bst &
  940. fi
  941. }
  942. __my_ps1_memo(){
  943. test -f memo.txt && echo "m:$(echo $(wc -c memo.txt) | cut -f 1 -d " ")"
  944. }
  945. __my_ps1_dirs(){
  946. dirs | wc -l
  947. }
  948. __my_ps1_jobs(){
  949. # __my_ps1_jobs [<num>]
  950. if test -n "$1"
  951. then
  952. jobs="$1"
  953. else
  954. jobs="`jobs | wc -l`"
  955. fi
  956. if test "$jobs" -gt 0
  957. then
  958. echo "JOBS:$jobs"
  959. fi
  960. }
  961. __my_ps1_dollar(){
  962. if test -z "$SHLVL"
  963. then
  964. printf "$1"
  965. else
  966. perl -e 'while($ARGV[0]-- > 0){print "$ARGV[1]";}' $SHLVL "$1"
  967. fi
  968. }
  969. __my_alert_fail(){
  970. test $laststatus -eq 0 || \
  971. echo "STATUS:${laststatus}"
  972. }
  973. # About ansi escape sequences
  974. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  975. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  976. if $inbash || $inzsh
  977. then
  978. if $inzsh
  979. then
  980. __attr_beg=$'%{\033['
  981. __attr_end='m%}'
  982. else
  983. __attr_beg='\[\033['
  984. __attr_end='m\]'
  985. fi
  986. __color_default="${__attr_beg}0${__attr_end}"
  987. __color_black="${__attr_beg}0;30${__attr_end}"
  988. __color_red="${__attr_beg}0;31${__attr_end}"
  989. __color_green="${__attr_beg}0;32${__attr_end}"
  990. __color_yellow="${__attr_beg}0;33${__attr_end}"
  991. __color_blue="${__attr_beg}0;34${__attr_end}"
  992. __color_magenta="${__attr_beg}0;35${__attr_end}"
  993. __color_cyan="${__attr_beg}0;36${__attr_end}"
  994. __color_white="${__attr_beg}0;37${__attr_end}"
  995. __color_light_black="${__attr_beg}1;30${__attr_end}"
  996. __color_light_red="${__attr_beg}1;31${__attr_end}"
  997. __color_light_green="${__attr_beg}1;32${__attr_end}"
  998. __color_light_yellow="${__attr_beg}1;33${__attr_end}"
  999. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  1000. __color_light_magenta="${__attr_beg}1;35${__attr_end}"
  1001. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  1002. __color_light_white="${__attr_beg}1;37${__attr_end}"
  1003. __color_bg_black="${__attr_beg}40${__attr_end}"
  1004. __color_bg_red="${__attr_beg}41${__attr_end}"
  1005. __color_bg_green="${__attr_beg}42${__attr_end}"
  1006. __color_bg_yellow="${__attr_beg}43${__attr_end}"
  1007. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1008. __color_bg_magenta="${__attr_beg}45${__attr_end}"
  1009. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1010. __color_bg_white="${__attr_beg}47${__attr_end}"
  1011. __attr_underline="${__attr_beg}4${__attr_end}"
  1012. __attr_reverse="${__attr_beg}7${__attr_end}"
  1013. __attr_bold="${__attr_beg}1${__attr_end}"
  1014. fi
  1015. # NOTE: tput is another easy way to set colors and background
  1016. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1017. # color blue.
  1018. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1019. if test "$TERM" != dumb
  1020. then
  1021. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1022. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1023. # color for ::
  1024. if test -z "$_HOSTCOLOR_1"
  1025. then
  1026. # default color used by tmux status line
  1027. _HOSTCOLOR_1=green
  1028. fi
  1029. eval "__my_c4=\${__color_light_${_HOSTCOLOR_1}}"
  1030. __my_c5="$__color_black$__color_bg_white" # color for SCR
  1031. __my_cdef="$__color_default"
  1032. fi
  1033. if $inbash
  1034. then
  1035. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1036. elif $inzsh
  1037. then
  1038. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1039. fi
  1040. __my_ps1_info1(){
  1041. # first line of PS1
  1042. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_moc)"
  1043. }
  1044. test -n "$__MY_SCRIPT" && \
  1045. __my_ps1_str_scr="SCR"
  1046. test -n "$SSH_CONNECTION" && \
  1047. __my_ps1_str_ssh="SSH"
  1048. test -n "$__MY_DTACH" && \
  1049. __my_ps1_str_dt="DT:`basename "$__MY_DTACH$"`"
  1050. __my_ps1_info2(){
  1051. # second line of PS1
  1052. echo $(__my_ps1_memo) $(__my_ps1_jobs) ${__my_ps1_str_scr} \
  1053. ${__my_ps1_str_ssh} ${__my_ps1_str_dt} $(__my_alert_fail) \
  1054. | sed -e 's/ /|/g'
  1055. }
  1056. __my_ps1_beg="${__my_c4}:: ${__my_cdef}"
  1057. __my_ps1_save_pos="\[\033[s\]"
  1058. __my_ps1_restore_pos="\[\033[u\]"
  1059. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1060. __my_ps1_move_15left="\[\033[15D\]"
  1061. # collapse when command line is too long and try to write over this string
  1062. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1063. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1064. if $inzsh
  1065. then
  1066. PROMPT="\
  1067. ${__my_ps1_beg}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info1)
  1068. ${__my_ps1_beg}\$(__my_ps1_info2) $(__my_ps1_dollar %#) "
  1069. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1070. elif $inbash
  1071. then
  1072. PS1="\
  1073. ${__my_ps1_beg}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info1)\n\
  1074. ${__my_ps1_beg}\D{%Y/%m/%d %H:%M} \$(__my_ps1_info2)${__my_ps1_right} $(__my_ps1_dollar \\$) "
  1075. else
  1076. true
  1077. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1078. fi
  1079. ###################################
  1080. # set header and titles
  1081. __my_set_header_line(){
  1082. # save current position
  1083. printf "\033[s"
  1084. # move to 0,0
  1085. printf "\033[0;0H"
  1086. # clear curent to eol
  1087. printf "\033[K"
  1088. # inverse color
  1089. printf "\033[7m"
  1090. printf "$1"
  1091. # restore color
  1092. printf "\033[0m"
  1093. # restore saved position
  1094. printf "\033[u"
  1095. }
  1096. __my_set_screen_name(){
  1097. # set window name
  1098. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1099. then
  1100. echo -ne "\033k$1\033\\"
  1101. fi
  1102. }
  1103. __my_set_title(){
  1104. case $TERM in
  1105. (rxvt*|xterm*|aterm|screen*)
  1106. test -t 1 &&
  1107. test -z "$EMACS" &&
  1108. echo -n -e "\033]0;$1\007"
  1109. ;;
  1110. esac
  1111. }
  1112. if test -n "$TMUX"
  1113. then
  1114. # running tmux locally
  1115. __terminal_title="\$(basename \${PWD})"
  1116. elif test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen' >/dev/null
  1117. then
  1118. # ssh connect from tmux terminal
  1119. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1120. else
  1121. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1122. fi
  1123. if $inzsh
  1124. then
  1125. precmd(){
  1126. laststatus=$?
  1127. eval __my_set_title ${__terminal_title}
  1128. }
  1129. else
  1130. if test -n "$PROMPT_COMMAND" && ! expr "$PROMPT_COMMAND" : '.*; *$' >/dev/null
  1131. then
  1132. PROMPT_COMMAND="${PROMPT_COMMAND};"
  1133. fi
  1134. if test -n "$PROMPT_COMMAND"
  1135. then
  1136. PROMPT_COMMAND="laststatus=\$?;${PROMPT_COMMAND}__my_set_title \"${__terminal_title}\";"
  1137. else
  1138. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\";"
  1139. fi
  1140. fi
  1141. laststatus=0